// sh4emuDlg.cpp: archivo de implementacin
//

#include "stdafx.h"
#include "sh4emu.h"
#include "sh4emuDlg.h"
#include ".\sh4emudlg.h"
#include <math.h>

// SDL
#ifdef WIN32
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#endif

#include "SDL.h"
// .. SDL

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Cuadro de dilogo CAboutDlg utilizado para el comando Acerca de

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Datos del cuadro de dilogo
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Compatibilidad con DDX/DDV

// Implementacin
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// Cuadro de dilogo de Csh4emuDlg



Csh4emuDlg::Csh4emuDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Csh4emuDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void Csh4emuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CHKMD, m_ChkMD);
	DDX_Control(pDX, IDC_CHKRB, m_ChkRB);
	DDX_Control(pDX, IDC_CHKBL, m_ChkBL);
}

BEGIN_MESSAGE_MAP(Csh4emuDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// Controladores de mensaje de Csh4emuDlg

BOOL Csh4emuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Agregar el elemento de men "Acerca de..." al men del sistema.

	// IDM_ABOUTBOX debe estar en el intervalo de comandos del sistema.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Establecer el icono para este cuadro de dilogo. El marco de trabajo realiza esta operacin
	//  automticamente cuando la ventana principal de la aplicacin no es un cuadro de dilogo
	SetIcon(m_hIcon, TRUE);			// Establecer icono grande
	SetIcon(m_hIcon, FALSE);		// Establecer icono pequeo

	// TODO: agregar aqu inicializacin adicional
	
	return TRUE;  // Devuelve TRUE  a menos que establezca el foco en un control
}

void Csh4emuDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Si agrega un botn Minimizar al cuadro de dilogo, necesitar el siguiente cdigo
//  para dibujar el icono. Para aplicaciones MFC que utilicen el modelo de documentos y vistas,
//  esta operacin la realiza automticamente el marco de trabajo.

void Csh4emuDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Contexto de dispositivo para dibujo

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrar icono en el rectngulo de cliente
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Dibujar el icono
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// El sistema llama a esta funcin para obtener el cursor que se muestra mientras el usuario arrastra
//  la ventana minimizada.
HCURSOR Csh4emuDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

typedef void opcode_f (long);

struct st_cmd
{
	long op;
	long mask;
	char * opdesc;
	opcode_f * funcion;
};

unsigned long registers[32];
double float_registers[32];
unsigned long SR = 0x700000F0; // Status Register
unsigned long SSR = 0; // Saved Status Register
unsigned long SPC = 0; // Saved Program Counter
unsigned long GBR = 0; // Global Base Register
unsigned long VBR = 0; // Vector Base Register
unsigned long SGR = 0; // Saved General Register 15
unsigned long DBR = 0; // Debug Base Register

unsigned long MACH = 0; // Multiply-And-Accumulate register High
unsigned long MACL = 0; // Multiply-And-Accumulate register Low
double FPUL = 0;
unsigned long PR = 0;   // Procedure Register
unsigned long PC = 0xA0000000;   // Program Counter
unsigned long delayslot = 0;
unsigned long NEXTPC = 0;
const unsigned long video_base = 0xa5000000;
const unsigned long video_size = 8 * 1024 * 1024;
const unsigned long mem_size =   16 * 1024 * 1024;

unsigned char * memoria;
unsigned char * video_mem;
FILE * fp;

const unsigned long base =   0x8C000000;
const unsigned long offset = 0x00010000;
const unsigned long ram_base = 0x0c000000;
const unsigned long ram_size = 0x01000000;

#define REG_MD (0x40000000)
#define REG_RB (0x20000000)
#define REG_BL (0x10000000)
#define REG_FD (0x00008000)
#define REG_M  (0x00000200)
#define REG_Q  (0x00000100)
#define REG_IMASK (0x000000F0)
#define REG_S  (0x00000002)
#define REG_T  (0x00000001)

float flunpack(unsigned char * mem)
{
	float f;
	BYTE * b = (BYTE *) &f;
	
	b[0] = mem[0];
	b[1] = mem[1];
	b[2] = mem[2];
	b[3] = mem[3];

	return f;
}

long SignExtend32(long x)
{
	return (~x) + 1;
}

long SignExtend8(unsigned char c)
{
	if (c & 0x80)
		return 0xFFFFFF00 | c;
	else
		return c;
}

long SignExtend12(unsigned long l)
{
	if (l & 0x0800)
		return 0xFFFFF000 | l;
	else
		return l;
}

void ReadMemoryF(unsigned long direccion, double * valor)
{
	if (direccion >= video_base && direccion <= video_base + video_size)
	{
		*valor = flunpack(&video_mem[direccion - video_base]);
	}
	else
	if (direccion >= base && direccion <= base + mem_size)
	{
		*valor = flunpack(&memoria[direccion - base]);
	}
	else
	if (direccion >= ram_base && direccion <= ram_base + ram_size)
	{
		*valor = flunpack(&memoria[direccion - ram_base]);
	}
	else
	{
		fprintf(fp, "ReadMemoryF: direccion %x invalida", direccion);
	}
}

void ReadMemoryB(unsigned long direccion, unsigned char * valor)
{
	if (direccion >= video_base && direccion <= video_base + video_size)
	{
		*valor = video_mem[direccion - video_base];
	}
	else
	if (direccion >= base && direccion <= base + mem_size)
	{
		*valor = memoria[direccion - base];
	}
	else
	if (direccion >= ram_base && direccion <= ram_base + ram_size)
	{
		*valor = memoria[direccion - ram_base];
	}
	else
	{
		fprintf(fp, "ReadMemoryB: direccion %x invalida", direccion);
	}
}

void mov2(long arg) // MOV.L @(disp,PC),Rn: (disp*4 + PC & H'FFFFFFFC + 4) -> Rn
{
	CString s;

	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long disp = (arg & 0x00FF);
	long source = disp*4 + (PC & 0xFFFFFFFC) + 4 - (base);

	registers[n] = memoria[source] |
		((memoria[source + 1] << 8) & 0x0000FF00) |
		((memoria[source + 2] << 16) & 0x00FF0000) |
		((memoria[source + 3] << 24) & 0xFF000000);

//	fprintf(fp, "n: %d, disp: %d, source:%x, mem[source]: %x, reg[n]: %x\r\n", n, disp, source, memoria[source], registers[n]);
}

void mov6(long arg) // MOV.L Rm,@Rn: Rm -> (Rn) (0010nnnnmmmm0010)
{
	CString s;

	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

//	fprintf(fp, "n: %d, m:%d, Rn:%x, Rm:%x\r\n", n, m, registers[n], registers[m] );
	if (registers[n] >= video_base && registers[n] <= video_base + video_size)
	{
	}
}

void mov7(long arg) // MOV.B @Rm,Rn: (Rm) -> sign extension -> Rn (0110nnnnmmmm0000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;
	unsigned char c;

	ReadMemoryB(registers[m], &c);

	registers[n] = SignExtend8(c);
}

void mov0(long arg) // MOV #imm,Rn: imm -> sign extension-> Rn (1110nnnn iiiiiiii)
{
	CString s;

	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long imm = (arg & 0x00FF);

	registers[n] = imm;

//	fprintf(fp, "n: %d, imm: %d, reg[n]: %x\r\n", n, imm, registers[n]);
}

void mov3(long arg) // MOV Rm,Rn: Rm -> Rn (0110nnnn mmmm0011)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	registers[n] = registers[m];

//	fprintf(fp, "m: %d, n: %d, reg[m]:%x\r\n", m, n, registers[m]);
}

void WriteMemoryW(unsigned long direccion, WORD valor)
{
	if (direccion >= video_base && direccion <= video_base + video_size)
	{
		video_mem[direccion - video_base] = valor & 0x00FF;
		video_mem[direccion - video_base + 1] = ((valor & 0xFF00) >> 8) & 0x00FF;
	}
	else
	if (direccion >= base && direccion <= base + mem_size)
	{
		memoria[direccion - base] = valor & 0x00FF;
		memoria[direccion - base + 1] = ((valor & 0xFF00) >> 8) & 0x00FF;
	}
	else
	if (direccion >= ram_base && direccion <= ram_base + ram_size)
	{
		memoria[direccion - ram_base] = valor & 0x00FF;
		memoria[direccion - ram_base + 1] = ((valor & 0xFF00) >> 8) & 0x00FF;
	}
	else
	{
		fprintf(fp, "WriteMemoryW: direccion %x invalida, valor %x", direccion, valor);
	}
}

void movw23(long arg) // MOV.W Rm, @(R0, Rn) : Rm -> (R0 + Rn) (0000nnnnmmmm0101)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	WriteMemoryW(registers[0] + registers[n], (WORD) (registers[m] & 0x00FF));
}

void WriteMemoryB(unsigned long direccion, BYTE valor)
{
	if (direccion >= video_base && direccion <= video_base + video_size)
	{
		video_mem[direccion - video_base] = valor;
	}
	else
	if (direccion >= base && direccion <= base + mem_size)
	{
		memoria[direccion - base] = valor;
	}
	else
	if (direccion >= ram_base && direccion <= ram_base + ram_size)
	{
		memoria[direccion - ram_base] = valor;
	}
	else
	{
		fprintf(fp, "WriteMemoryB: direccion %x invalida, valor %x", direccion, valor);
	}
}

void mov4(long arg) // MOV.B Rm, @Rn: Rm -> (Rn) (0010nnnn mmmm0000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	WriteMemoryB(registers[n], (BYTE) registers[m]);

//	fprintf(fp, "m: %d, n: %d, reg[m]:%x\r\n", m, n, registers[m]);
}

void bf(long arg) // BF label (10001011 ssssssss)
{
	long s = SignExtend8(arg & 0x00FF)*2 + 4 + PC;

	if ((SR & REG_T) == 0)
	{
		fprintf(fp, "Cambiando PC de %x a %x. arg %x\r\n", PC, s, arg & 0x00FF);
		NEXTPC = s;
	}
}

void bra(long arg) // BRA label (1010dddd dddddddd)
{
	long disp = SignExtend12(arg & 0x0FFF) * 2 + PC + 4;

	fprintf(fp, "Cambiando PC de %x a %x. arg %x\r\n", PC, disp, arg & 0x0FFF);
	delayslot = disp;
}

void nop(long arg) // NOP (00000000 00001001)
{
}

void shll16(long arg) // SHLL16 Rn (0100nnnn 00101000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] << 16;
}

void shllr6(long arg) // SHLL16 Rn (0100nnnn 00101001)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] >> 16;
}

void shlr95(long arg) // SHLR Rn : 0 -> Rn -> T (0100nnnn 00000001)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	if (registers[n] & 0x0001)
		SR = SR | REG_T;
	else
		SR = SR & ~REG_T;
	
	registers[n] = registers[n] >> 1;
}

void shll2(long arg) // SHLL2 Rn: Rn << 2 -> Rn (0100nnnn 00001000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] << 2;

//	fprintf(fp, "n: %d, reg[n]:%x\r\n", n, registers[n]);
}

void shlr2(long arg) // SHLR2 Rn: Rn >> 2 -> Rn (0100nnnn 00001001)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] >> 2;

//	fprintf(fp, "n: %d, reg[n]:%x\r\n", n, registers[n]);
}

void shlr16(long arg) // SHLR16 Rn: Rn >> 16 -> Rn (0100nnnn 00101001)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] >> 16;

//	fprintf(fp, "n: %d, reg[n]:%x\r\n", n, registers[n]);
}

void sts164(long arg) // STS MACL, Rn : MACL -> Rn (0000nnnn 00011010)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = MACL;
}

void bfs(long arg) // 10001111dddddddd
{
	CString s;
	long disp = SignExtend8(arg & 0x00FF)*2 + PC + 4;

//	= ((~(arg & 0x00FF)) & 0xFF) + 1)*2 + PC + 4;

	if ((SR & REG_T) == 0)
	{
		fprintf(fp, "Cambiando PC de %x a %x. arg %x\r\n", PC, disp, arg & 0x00FF);
		delayslot = disp;
	}
}

void add40(long arg)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long s = SignExtend8(arg & 0x00FF);

	registers[n] += s;
}

void mull(long arg) // Rn x Rm -> MACL (0000nnnn mmmm0111)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;;

	MACL = (registers[n] * registers[m]) & 0xFFFFFFFF;
}

void add39(long arg) // ADD Rm, Rn : Rn + Rm -> Rn (0011nnnn mmmm1100)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;;

	registers[n] += registers[m];
}

void xor83(long arg) // (0010 nnnn mmmm 1010)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	registers[n] = registers[n] ^ registers[m];
}

void and72(long arg) // (0010 nnnn mmmm 1001)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	registers[n] = registers[n] & registers[m];
}

void lds214(long arg) // LDS Rm, FPUL : Rm -> FPUL (0100mmmm 01011010)
{
	long m = ((arg & 0x0F00) >> 8) & 0x0F;

	FPUL = registers[m];
//	fprintf(fp, "lds214: FPUL = %f\r\n", FPUL);
}

void float193(long arg) // FLOAT FPUL, FRn : (float) FPUL -> FRn (1111nnnn 00101101)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	float_registers[n] = FPUL;
//	fprintf(fp, "float193: FPUL = %f\r\n", FPUL);
}

void mova34(long arg) // MOVA @(disp, PC), R0 : disp x 4 + PC & 0xFFFFFFFC + 4 -> R0 (11000111 dddddddd)
{
	long disp = arg & 0x00FF;

	disp *= 4;
	disp += (PC & 0xFFFFFFFC) + 4;

	registers[0] = disp;
//	fprintf(fp, "mova34: disp %x\r\n", disp);
}

void fmovs173(long arg) // FMOV.S @Rm, FRn : (Rm) -> FRn (1111nnnn mmmm1000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

//	fprintf(fp, "fmovs173: m:%d, n:%d\r\n", m, n);
	ReadMemoryF(registers[m], &float_registers[n]);
}

void fdiv192(long arg) // FDIV FRm, FRn : FRn/FRm -> FRn (1111nnnn mmmm0011)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	if (float_registers[m] == 0)
	{
		fprintf(fp, "EXCEPTION: float_registers[m] = 0, n:%d, m:%d\r\n", n, m);
	}
	else
	{
		float_registers[n] = float_registers[n] / float_registers[m];
//		fprintf(fp, "fdiv192: n:%d, m:%d, float_registers[n] = %f\r\n", n, m, float_registers[n]);
	}
}

void fmul195(long arg) // FMUL FRn * FRm -> FRn (1111nnnn mmmm0010)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	float_registers[n] = float_registers[n] * float_registers[m];
//	fprintf(fp, "fdiv192: n:%d, m:%d, float_registers[n] = %f\r\n", n, m, float_registers[n]);
}

void fadd189(long arg) // FADD FRm, FRn : FRn + FRm -> FRn (1111nnnn mmmm0000)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	float_registers[n] = float_registers[n] + float_registers[m];
//	fprintf(fp, "fdiv192: n:%d, m:%d, float_registers[n] = %f\r\n", n, m, float_registers[n]);
}

void ftrc199(long arg) // FTRC FRm, FPUL : (long) FRm -> FPUL (1111mmmm00111101)
{
	long m = ((arg & 0x0F00) >> 8) & 0x0F;

// float_registers[n] = float_registers[n] * float_registers[m];
	FPUL = floorf(float_registers[m]);
//	fprintf(fp, "fdiv192: n:%d, m:%d, float_registers[n] = %f\r\n", n, m, float_registers[n]);
}

void neg67(long arg) // NEG Rm, Rn : 0 - Rm -> Rn (0110nnnn mmmm1011)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;
	long m = ((arg & 0x00F0) >> 4) & 0x0F;

	registers[n] = 0 - registers[m];
}

void sts218(long arg) // STS FPUL, Rn : FPUL -> Rn (0000nnnn 01011010)
{
	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = (long) FPUL;
//	fprintf(fp, "fdiv192: n:%d, m:%d, float_registers[n] = %f\r\n", n, m, float_registers[n]);
}

void dt(long arg)
{
	CString s;

	long n = ((arg & 0x0F00) >> 8) & 0x0F;

	registers[n] = registers[n] - 1;

	if (registers[n] == 0)
	{
		fprintf(fp, "Seteando REG_T\r\n");
		SR = SR | REG_T;
	}
	else
	{
		fprintf(fp, "Limpiando REG_T\r\n");
		SR = SR & (~REG_T);
	}

//	fprintf(fp, "n: %d, reg[n]: %x\r\n", n, registers[n]);
}

struct st_cmd opcodes[] =
{
	// Fixed Point Transfer Instructions
	// pgina 140
	{ 0xE000, 0xF000, "MOV", mov0},
	{ 0x9000, 0xF000, "MOV.W" },
	{ 0xD000, 0xF000, "MOV.L", mov2 },
	{ 0x6003, 0xF00F, "MOV", mov3 },
	{ 0x2000, 0xF00F, "MOV.B", mov4 },
	{ 0x2001, 0xF00F, "MOV.W" },
	{ 0x2002, 0xF00F, "MOV.L", mov6 },
	{ 0x6000, 0xF00F, "MOV.B", mov7 },
	{ 0x6001, 0xF00F, "MOV.W" },
	{ 0x6002, 0xF00F, "MOV.L" },
	{ 0x2004, 0xF00F, "MOV.B" }, // 10
	{ 0x2005, 0xF00F, "MOV.W" },
	{ 0x2006, 0xF00F, "MOV.L" },
	{ 0x6008, 0xF00F, "MOV.B" },
	{ 0x6005, 0xF00F, "MOV.W" },
	{ 0x5005, 0xF00F, "MOV.L" },
	{ 0x8000, 0xFF00, "MOV.B" },
	{ 0x8100, 0xFF00, "MOV.W" },
	{ 0x1000, 0xF000, "MOV.L" },
	{ 0x8400, 0xFF00, "MOV.B" },
	{ 0x8500, 0xFF00, "MOV.W" }, // 20
	{ 0x5000, 0xF000, "MOV.L" },
	{ 0x0004, 0xF00F, "MOV.B" },
	{ 0x0005, 0xF00F, "MOV.W", movw23 }, // 23
	{ 0x0006, 0xF00F, "MOV.L" },
	{ 0x000C, 0xF00F, "MOV.B" },
	{ 0x000D, 0xF00F, "MOV.W" },
	{ 0x000E, 0xF00F, "MOV.L" },
	// pgina 141
	{ 0xC000, 0xFF00, "MOV.B" },
	{ 0xC100, 0xFF00, "MOV.W" },
	{ 0xC200, 0xFF00, "MOV.L" }, // 30
	{ 0xC400, 0xFF00, "MOV.B" },
	{ 0xC500, 0xFF00, "MOV.W" },
	{ 0xC600, 0xFF00, "MOV.L" },
	{ 0xC700, 0xFF00, "MOVA", mova34 }, // 34
	{ 0x0029, 0xF0FF, "MOVT" },
	{ 0x6008, 0xF00F, "SWAP.B" },
	{ 0x6009, 0xF00F, "SWAP.W" },
	{ 0x200D, 0xF00F, "XTRCT" },

	// Arithmetic Operator Instructions
	{ 0x300C, 0xF00F, "ADD", add39 },
	{ 0x7000, 0xF000, "ADD", add40 },
	{ 0x300E, 0xF00F, "ADDC" },
	{ 0x300F, 0xF00F, "ADDV" },
	{ 0x8800, 0xFF00, "CMP/EQ" },
	{ 0x3000, 0xF00F, "CMP/EQ" },
	{ 0x3002, 0xF00F, "CMP/HS" },
	{ 0x3003, 0xF00F, "CMP/GE" },
	{ 0x3006, 0xF00F, "CMP/HI" },
	{ 0x3007, 0xF00F, "CMP/GT" },
	{ 0x4011, 0xF0FF, "CMP/PZ" },
	{ 0x4015, 0xF0FF, "CMP/PL" },
	{ 0x200C, 0xF00F, "CMP/STR" },
	{ 0x3004, 0xF00F, "DIV1" },
	{ 0x2007, 0xF00F, "DIV0S" },
	{ 0x0019, 0xFFFF, "DIV0U" },
	{ 0x300D, 0xF00F, "DMULS.L" },
	{ 0x3005, 0xF00F, "DMULU.L" },
	{ 0x4010, 0xF0FF, "DT", dt }, // 57
	{ 0x600E, 0xF00F, "EXTS.B" },
	// pgina 143
	{ 0x600F, 0xF00F, "EXTS.W" },
	{ 0x600C, 0xF00F, "EXTU.B" },
	{ 0x600D, 0xF00F, "EXTU.W" },
	{ 0x000F, 0xF00F, "MAC.L" },
	{ 0x400F, 0xF00F, "MAC.W" },
	{ 0x0007, 0xF00F, "MUL.L", mull },
	{ 0x200F, 0xF00F, "MULS.W" },
	{ 0x200E, 0xF00F, "MULU.W" },
	{ 0x600B, 0xF00F, "NEG", neg67 },
	{ 0x6009, 0xF00F, "NEGC" },
	{ 0x3008, 0xF00F, "SUB" },
	{ 0x300A, 0xF00F, "SUBC" },
	{ 0x300B, 0xF00F, "SUBV" },
	// Logic Operation Instructions
	// pgina 144
	{ 0x2009, 0xF00F, "AND", and72 }, // 72
	{ 0xC900, 0xFF00, "AND" },
	{ 0xCD00, 0xFF00, "AND.B" },
	{ 0x6007, 0xF00F, "NOT" },
	{ 0x200B, 0xF00F, "OR" },
	{ 0xCB00, 0xFF00, "OR" },
	{ 0xCF00, 0xFF00, "OR.B" },
	{ 0x401B, 0xF0FF, "TAS.B" },
	{ 0x2008, 0xF00F, "TST" },
	{ 0xC800, 0xFF00, "TST" },
	{ 0xCC00, 0xFF00, "TST.B" },
	{ 0x200A, 0xF00F, "XOR", xor83 },
	{ 0xCA00, 0xFF00, "XOR" },
	{ 0xCE00, 0xFF00, "XOR.B" },
	// Shift Instructions
	// pgina 145
	{ 0x4004, 0xF0FF, "ROTL" },
	{ 0x4005, 0xF0FF, "ROTR" },
	{ 0x4024, 0xF0FF, "ROTCL" },
	{ 0x4025, 0xF0FF, "ROTCR" },
	{ 0x400C, 0xF00F, "SHAD" },
	{ 0x4020, 0xF0FF, "SHAL" },
	{ 0x4021, 0xF0FF, "SHAR" },
	{ 0x400D, 0xF00F, "SHLD" },
	{ 0x4000, 0xF0FF, "SHLL" },
	{ 0x4001, 0xF0FF, "SHLR", shlr95 }, // 95
	{ 0x4008, 0xF0FF, "SHLL2", shll2 }, // 96
	{ 0x4009, 0xF0FF, "SHLR2", shlr2 }, // 97
	{ 0x4018, 0xF0FF, "SHLL8" },
	{ 0x4019, 0xF0FF, "SHLR8" },
	{ 0x4028, 0xF0FF, "SHLL16", shll16 }, // 100
	{ 0x4029, 0xF0FF, "SHLR16", shlr16}, // 101
	// Branch Instructions
	// pgina 146
	{ 0x8B00, 0xFF00, "BF", bf },
	{ 0x8F00, 0xFF00, "BF/S", bfs },
	{ 0x8900, 0xFF00, "BT" },
	{ 0x8D00, 0xFF00, "BT/S" },
	{ 0xA000, 0xF000, "BRA", bra },
	{ 0x0023, 0xF0FF, "BRAF" },
	{ 0xB000, 0xF000, "BSR" },
	{ 0x0003, 0xF0FF, "BSRF" },
	{ 0x402B, 0xF0FF, "JMP" }, // 110
	{ 0x400B, 0xF0FF, "JSR" },
	{ 0x000B, 0xFFFF, "RTS" },
	// System Control Instructions
	// pgina 147
	{ 0x0028, 0xFFFF, "CLRMAC" },
	{ 0x0048, 0xFFFF, "CLRS" },
	{ 0x0008, 0xFFFF, "CLRT" },
	{ 0x400E, 0xF0FF, "LDC" },
	{ 0x401E, 0xF0FF, "LDC" },
	{ 0x402E, 0xF0FF, "LDC" },
	{ 0x403E, 0xF0FF, "LDC" },
	{ 0x404E, 0xF0FF, "LDC" }, // 120
	{ 0x40FA, 0xF0FF, "LDC" },
	{ 0x408E, 0xF08F, "LDC" },
	{ 0x4007, 0xF0FF, "LDC.L" },
	{ 0x4017, 0xF0FF, "LDC.L" },
	{ 0x4027, 0xF0FF, "LDC.L" },
	{ 0x4037, 0xF0FF, "LDC.L" },
	{ 0x4047, 0xF0FF, "LDC.L" },
	{ 0x40F7, 0xF0FF, "LDC.L" },
	{ 0x4087, 0xF08F, "LDC.L" },
	{ 0x400A, 0xF0FF, "LDS" }, // 130
	{ 0x401A, 0xF0FF, "LDS" },
	{ 0x402A, 0xF0FF, "LDS" },
	{ 0x4005, 0xF0FF, "LDS.L" },
	{ 0x4015, 0xF0FF, "LDS.L" },
	{ 0x4025, 0xF0FF, "LDS.L" },
	{ 0x0038, 0xFFFF, "LDTLB" },
	{ 0x00C3, 0xF0FF, "MOVCA.L" },
	{ 0x0009, 0xFFFF, "NOP", nop },
	{ 0x0093, 0xF0FF, "OCBI" },
	{ 0x00A3, 0xF0FF, "OCBP" }, // 140
	{ 0x00B3, 0xF0FF, "OCBWB" },
	{ 0x0083, 0xF0FF, "PREF" },
	{ 0x002B, 0xFFFF, "RTE" },
	// pgina 148
	{ 0x0058, 0xFFFF, "SETS" },
	{ 0x0018, 0xFFFF, "SETT" },
	{ 0x001B, 0xFFFF, "SLEEP" },
	{ 0x0002, 0xF0FF, "STC" },
	{ 0x0012, 0xF0FF, "STC" },
	{ 0x0022, 0xF0FF, "STC" },
	{ 0x0032, 0xF0FF, "STC" }, // 150
	{ 0x0042, 0xF0FF, "STC" },
	{ 0x003A, 0xF0FF, "STC" },
	{ 0x00FA, 0xF0FF, "STC" },
	{ 0x0082, 0xF08F, "STC" },
	{ 0x4003, 0xF0FF, "STC.L" },
	{ 0x4013, 0xF0FF, "STC.L" },
	{ 0x4023, 0xF0FF, "STC.L" },
	{ 0x4033, 0xF0FF, "STC.L" },
	{ 0x4043, 0xF0FF, "STC.L" },
	{ 0x4034, 0xF0FF, "STC.L" }, // 160
	{ 0x40F2, 0xF0FF, "STC.L" },
	{ 0x4083, 0xF08F, "STC.L" },
	{ 0x000A, 0xF0FF, "STS" },
	{ 0x001A, 0xF0FF, "STS", sts164 }, // 164
	{ 0x002A, 0xF0FF, "STS" },
	{ 0x4002, 0xF0FF, "STS.L" },
	{ 0x4012, 0xF0FF, "STS.L" },
	{ 0x4022, 0xF0FF, "STS.L" },
	{ 0xC300, 0xFF00, "TRAPA" },
	// Floating-Point Single-Precision Instructions
	{ 0xF08D, 0xF0FF, "FLDI0" }, // 170
	{ 0xF09D, 0xF0FF, "FLDI1" },
	{ 0xF00C, 0xF00F, "FMOV" },
	{ 0xF008, 0xF00F, "FMOV.S", fmovs173 }, // 173
	{ 0xF006, 0xF00F, "FMOV.S" },
	{ 0xF009, 0xF00F, "FMOV.S" },
	{ 0xF00A, 0xF00F, "FMOV.S" },
	{ 0xF00B, 0xF00F, "FMOV.S" },
	{ 0xF007, 0xF00F, "FMOV.S" },
	{ 0xF00C, 0xF11F, "FMOV" },
	{ 0xF008, 0xF10F, "FMOV" }, // 180
	{ 0xF006, 0xF10F, "FMOV" },
	{ 0xF009, 0xF10F, "FMOV" },
	{ 0xF00A, 0xF01F, "FMOV" },
	{ 0xF00B, 0xF01F, "FMOV" },
	{ 0xF007, 0xF01F, "FMOV" },
	{ 0xF01D, 0xF0FF, "FLDS" },
	{ 0xF00D, 0xF0FF, "FSTS" },
	{ 0xF05D, 0xF0FF, "FABS" },
	{ 0xF000, 0xF00F, "FADD", fadd189 }, // 189
	{ 0xF004, 0xF00F, "FCMP/EQ" }, // 190
	{ 0xF007, 0xF00F, "FCMP/GT" },
	{ 0xF003, 0xF00F, "FDIV", fdiv192 }, // 192
	{ 0xF02D, 0xF0FF, "FLOAT", float193 }, // 193
	{ 0xF00E, 0xF00F, "FMAC" },
	{ 0xF002, 0xF00F, "FMUL", fmul195 }, // 195
	{ 0xF04D, 0xF0FF, "FNEG" },
	{ 0xF06D, 0xF0FF, "FSQRT" },
	{ 0xF001, 0xF00F, "FSUB" },
	{ 0xF03D, 0xF0FF, "FTRC", ftrc199 }, // 199
	{ 0xF05D, 0xF1FF, "FABS" }, // 200
	{ 0xF000, 0xF11F, "FADD" },
	{ 0xF004, 0xF11F, "FCMP/EQ" },
	{ 0xF005, 0xF11F, "FCMP/GT" },
	{ 0xF003, 0xF11F, "FDIV" },
	{ 0xF0BD, 0xF1FF, "FCNVDS" },
	{ 0xF0AD, 0xF1FF, "FCNVSD" },
	{ 0xF02D, 0xF1FF, "FLOAT" },
	{ 0xF002, 0xF11F, "FMUL" },
	{ 0xF02D, 0xF1FF, "FNEG" },
	{ 0xF06D, 0xF1FF, "FSQRT" }, // 210
	{ 0xF001, 0xF11F, "FSUB" },
	{ 0xF03D, 0xF1FF, "FTRC" },
	// Floating-Point Control Instructions
	{ 0x406A, 0xF0FF, "LDS" },
	{ 0x405A, 0xF0FF, "LDS", lds214 }, // 214
	{ 0x4066, 0xF0FF, "LDS.L" },
	{ 0x4056, 0xF0FF, "LDS.L" },
	{ 0x006A, 0xF0FF, "STS" },
	{ 0x005A, 0xF0FF, "STS", sts218 },
	{ 0x4062, 0xF0FF, "STS.L" },
	{ 0x4052, 0xF0FF, "STS.L" }, // 220
	// Floating-Point Graphics Acceleration Instructions
	{ 0xF10C, 0xF11F, "FMOV" },
	{ 0xF01C, 0xF11F, "FMOV" },
	{ 0xF11C, 0xF11F, "FMOV" },
	{ 0xF108, 0xF10F, "FMOV" }, // 224
	{ 0xF109, 0xF10F, "FMOV" },
	{ 0xF106, 0xF10F, "FMOV" },
	{ 0xF01A, 0xF01F, "FMOV" },
	{ 0xF01B, 0xF01F, "FMOV" },
	{ 0xF017, 0xF01F, "FMOV" },
	{ 0xF0ED, 0xF0FF, "FIPR" },
	{ 0xF1FD, 0xF3FF, "FTRV" },
	{ 0xFBFD, 0xFFFF, "FRCHG" },
	{ 0xF3FD, 0xFFFF, "FSCHG" },
	{ 0, 0, NULL}
};


void Csh4emuDlg::OnBnClickedButton1()
{
	CString s;
	long idx, cnt = 0;
	unsigned char c, * p, instr1, instr2;
	bool fin = false, salto = false;

	memoria = (unsigned char *) malloc(sizeof(char) * mem_size); // 16 megabytes

	if (!memoria)
	{
		s.Format("No se pudo asignar %d bytes de memoria.", 16 * 1024 * 1024);
		AfxMessageBox(s);
		return;
	}
	
	video_mem = (unsigned char *) malloc(sizeof(char) * video_size); // 8 megabytes

	if (!video_mem)
	{
		s.Format("No se pudo asignar %d bytes de memoria.", 8 * 1024 * 1024);
		AfxMessageBox(s);
		return;
	}

	fp = fopen("1st_read.bin", "rb");

	if (!fp)
	{
		AfxMessageBox("No se pudo abrir 1st_read.bin");
		delete memoria;
		return;
	}
	
	ActualizarRegistros();
	
	idx = offset;

	for (c = fgetc(fp); !feof(fp); c = fgetc(fp))
	{
		memoria[idx++] = c;
		cnt++;
	}

	fclose(fp);

	CString op;
/*	long Rn, Rn2;
	long disp;
	long imm; */
	int i;

	PC = base + offset;

	fp = fopen("disasm.txt", "w");
	
	for (p = &memoria[offset]; fin == false; )
	{
		instr1 = *p;
		instr2 = *(p+1);

		for (i = 0; opcodes[i].opdesc; i++)
		{
			if (((((instr2 << 8) & 0xFF00) | (instr1 & 0x00FF)) & opcodes[i].mask) == opcodes[i].op)
			{
				fprintf(fp, "PC: %x %s\r\n", PC, opcodes[i].opdesc);
				if (opcodes[i].funcion)
					((opcodes[i].funcion) ((((instr2 << 8) & 0xFF00) | (instr1 & 0x00FF))));
				else
					fprintf(fp, "opcode no implementado: %s (%d)\r\n", opcodes[i].opdesc, i);
				break;
			}
		}

		if (opcodes[i].opdesc == NULL)
		{
			fprintf(fp, "No se encontr opcode %x %x\r\n", instr2 & 0xFF, instr1 & 0xFF);
		}

		if (delayslot > 0)
		{
			if (salto == false)
			{
				salto = true;
				p += 2;
				PC += 2;
			}
			else
			{
				salto = false;
				PC = delayslot;
				delayslot = 0;
				p = &memoria[PC - base];
			}
		}
		else
		{
			if (NEXTPC > 0)
			{
				PC = NEXTPC;
				p = &memoria[PC - base];
				NEXTPC = 0;
			}
			else
			{
				p += 2;
				PC += 2;
			}
		}

		if (p - &memoria[offset] > cnt)
			fin = true;
	}

	fclose(fp);
	
	AfxMessageBox("Fin.");

	free(memoria);
	free(video_mem);
}

void Csh4emuDlg::ActualizarRegistros(void)
{
	if (SR & REG_MD)
		m_ChkMD.SetCheck(BST_CHECKED);
	else
		m_ChkMD.SetCheck(BST_UNCHECKED);

	if (SR & REG_RB)
		m_ChkRB.SetCheck(BST_CHECKED);
	else
		m_ChkRB.SetCheck(BST_UNCHECKED);

	if (SR & REG_BL)
		m_ChkBL.SetCheck(BST_CHECKED);
	else
		m_ChkBL.SetCheck(BST_UNCHECKED);
}
